-- openURL.lua (version 0.1, 5/5/2010)
-- Kevin Reiss kevin.reiss@mail.cuny.edu
--
-- Opens OpenURL menu 


-- define your OpenURL resolver
local myArticleResolver = GetSetting("OpenUrlBaseArticle");
local myBookResolver = GetSetting("OpenUrlBaseBook");
local myBranding = GetSetting("OpenUrlBrand");


-- set scriptActive to true for this script to run, false to stop it from running.
local scriptActive = GetSetting("Active");
-- set autoSearch to true for this script to automatically run the search when the request is opened.
local autoSearch = GetSetting("AutoSearch");

-- don't change anything below this line
local interfaceMngr = nil;
local browser = nil;
function Init()
	if scriptActive then
		interfaceMngr = GetInterfaceManager();
		
		-- Create browser
		browser = interfaceMngr:CreateBrowser(myBranding, myBranding, "Script");

		-- Create button
		-- what search would be run in this context?
		browser:CreateButton("Search", GetClientImage("Search32"), "Search", myBranding);

		browser:Show();
		
		if autoSearch then
			Search();
		end
	end
end

function Search()
	
		if GetFieldValue("Transaction", "RequestType") == "Article" then
			-- build URL for articles
			local myGenre = "genre=article";
			local tempYear = GetFieldValue("Transaction", "PhotoJournalYear");
				if tempYear:len()>4 then
					tempYear=tempYear:match("%d%d%d%d")
				end
			local myYear = "&rft.date=" .. tempYear;
			local myISxN = "&rft.issn=" .. GetFieldValue("Transaction", "ISSN");
			local myAtitle = "&rft.atitle=" .. GetFieldValue("Transaction", "PhotoArticleTitle");
			local myVolume = "&rft.volume=" .. GetFieldValue("Transaction", "PhotoJournalVolume");
			local myIssue = "&rft.issue=" .. GetFieldValue("Transaction", "PhotoJournalIssue");
			local myPages = "&rft.spage=" .. GetFieldValue("Transaction", "PhotoJournalInclusivePages");
			local myTitle = "&rft.title=" .. GetFieldValue("Transaction", "PhotoJournalTitle");
			local myAuthor = "&rft.au=" .. GetFieldValue("Transaction", "PhotoArticleAuthor");
			myURL = myArticleResolver .. "?" .. myGenre .. myYear .. myISxN .. myAtitle .. myVolume .. myIssue .. myPages.. myTitle .. myAuthor;
		else
			-- build URL for books and other 'returnables'
			local myGenre = "genre=book";
			local tempYear = GetFieldValue("Transaction", "LoanDate");
				if tempYear:len()>4 then
					tempYear=tempYear:match("%d%d%d%d")
				end
			local myYear = "&rft.date=" .. tempYear;
			local myISxN = "&rft.isbn=" .. GetFieldValue("Transaction", "ISSN");
			local myTitle = "&rft.title=" .. GetFieldValue("Transaction", "LoanTitle");
			local myAuthor = "&rft.au=" .. GetFieldValue("Transaction", "LoanAuthor");
			myURL = myBookResolver .. "?" .. myGenre .. myYear .. myISxN .. myTitle .. myAuthor;
		end
	
	browser:Navigate(myURL);
	
end
